/**************************************************************************
                    DK-1519.h
**************************************************************************/
/**********************************************************
Total:            RFM-DK for 1519
Version:          V1.0
Prosessor:        PIC16F1519
Author:           Meng Fanbing
Email:            cal01@hoperf.com
***********************************************************/
/***********************************************************

                   ---------------------
         MCLR --- | VPP             RB7 | --- PGD
         nSEL --- | RA0             RB6 | --- PGC
       RFdata --- | RA1             RB5 | --- IRQ_0
       RF_IO1 --- | RA2             RB4 | --- IRQ_1
       RF_IO2 --- | RA3             RB3 | --- KEY4
      LCD_IRQ --- | RA4             RB2 | --- KEY3
     LCD_DATA --- | RA5             RB1 | --- KEY2
      LCD_CLK --- | RE0             RB0 | --- KEY1
       LCD_WR --- | RE1             VDD |
       LCD_CS --- | RE2             VSS |
                  | VDD             RD7 | --- D7
                  | VSS             RD6 | --- D6
                  | RA7             RD5 | --- D5
     		  --- | RA6             RD4 | --- D4
                  | RC0             RC7 | --- RXD
                  | RC1             RC6 | --- TXD
      	 Buzz --- | RC2             RC5 | --- MISO
      	  MSCK--- | RC3             RC4 | --- MOSI
          POR --- | RD0             RD3 | --- D3
           D1 --- | RD1             RD2 | --- D2
                   ---------------------
                        PIC16LF1519

***********************************************************/
#include<pic.h>
#include  <stdbool.h>

typedef unsigned char byte;
typedef unsigned int  word;
typedef unsigned long lword;

typedef union 					//־λṹ
{
 	struct 
 	{
 		byte  _FlagBit0:1;			//bit0
 		byte  _FlagBit1:1;	 		//bit1
 		byte  _FlagBit2:1;			//bit2
 		byte  _FlagBit3:1;			//bit3
 		byte  _FlagBit4:1;			//bit4
 		byte  _FlagBit5:1;			//bit5
 		byte  _FlagBit6:1;			//bit6
 		byte  _FlagBit7:1;			//bit7
 	}BBITS;
 	byte BBYTE;
}FlagSTR;

//#define  nSEL_CMD  RA0
#define  RFdata    RA1
//#define  RF_IO1    RA2
//#define  RF_IO2    RA3
#define  LCD_IRQ       RA4
#define  LCD_DATA      RA5

#define  LCD_CLK    RE0
#define  LCD_WR     RE1
#define  LCD_CS     RE2

#define  KEY1      RB0
#define  KEY2      RB1
#define  KEY3      RB2
#define  KEY4      RB3
#define  IRQ_1     RB4
#define  IRQ_0     RB5

#define  Buzz      RC2
#define  MSCK      RC3
#define  MOSI      RC4
#define  MISO      RC5
#define  TXD       RC6
#define  RXD       RC7

#define  TLED1     RD1
#define  TLED2     RD2
#define  TLED3     RD3
#define  TLED4     RD4
#define  TLED5     RD5
#define  TLED6     RD6
#define  RLED1     RD7


extern unsigned int systime;
extern unsigned int systime1;
extern  byte 	FreqSel;			//Ƶѡ
extern  byte  TypeID;

extern bit set_frame;
extern byte rfm_br;                //ѡ
extern byte rfm_pwr;                //ѡ
extern word rfm_fdev;              //Ƶƫѡ
extern word rf_tcount;         //
extern word rf_rcount;         //ռ
extern byte rf_rssi_value;

extern void Port_init();
extern void Config_init(void);
extern void timer0_init();

extern void Beep_init(void);
extern void BeepOn(void);
extern void BeepOff(void);
extern void led_tx();
extern void led_rx();
extern void led_alltx();
extern void led_off();