/***********************************************************************
                  LCD.c
************************************************************************/
#include "DK-1519.h"
#include "LCD.h"
#include "Keyscan.h"

byte lcddisp[32];
byte jmsdisp;
//struct dispflash disp;
//struct CONFIG  config;
//unsigned long freq_tab[4] = {315000000, 434000000, 869000000, 915000000};	//20111028޸
//word dr_tab[8] = {12,24,48,96,192,384,576,1152};
//word fdev_tab[8] = {50,100,200,300,450,600,750,900};
//word bw_tab[8] = {400,600,800,1000,1200,1500,1800,2100};


byte font_tab[18] = {
      0x77, 0x24, 0x5d, 0x6d, 0x2e, 0x6b, 0x7b, 0x25, 0x7f, 0x6f,
      //0	  1     2     3     4     5     6     7     8     9
      0x3f, 0x7f, 0x53, 0x77, 0x5b, 0x1b,0x5a,0x6b
      //A	  B     C     D     E     F    t    s
                        };

//---------------------------------------------------------
//function:	lcd write one data
//parameters:	byte addr, byte dispdata
//return value:	none
//---------------------------------------------------------
void lcd_write_data( byte addr, byte dispdata )
{
	byte rwdata;
	byte i,k;
	
	LCD_CS = 0;
    LCD_WR = 1;
	for ( k = 0; k < 2; k++ );
	rwdata = 0x05;
	for ( i = 0; i < 3; i++ ) 
   {
		if ( rwdata & 0x04 )
			LCD_DATA = 1;
		else
			LCD_DATA = 0;
		for ( k = 0; k < 2; k++ );
		//LCD_WR = 0;
        LCD_CLK = 0;
		for ( k = 0; k < 5; k++ );
		//LCD_WR = 1;
        LCD_CLK = 1;
        NOP();
		rwdata <<= 1;
	}
	rwdata = addr;
	for ( i = 0; i < 6; i++ ) 
    {
		if ( rwdata & 0x20 )
			LCD_DATA = 1;
		else
			LCD_DATA = 0;
		for ( k = 0; k < 2; k++ );
		//LCD_WR = 0;
        LCD_CLK = 0;
		for ( k = 0; k < 5; k++ );
		//LCD_WR = 1;
        LCD_CLK = 1;
        NOP();
		rwdata <<= 1;
	}
	rwdata = dispdata;
	for ( i = 0; i < 8; i++ ) 
    {
		if ( rwdata & 0x01 )
			LCD_DATA = 1;
		else
			LCD_DATA = 0;
		for ( k = 0; k < 2; k++ );
		//LCD_WR = 0;
        LCD_CLK = 0;
		for ( k = 0; k < 5; k++ );
		//LCD_WR = 1;
        LCD_CLK = 1;
        NOP();
		rwdata >>= 1;
	}
	LCD_DATA = 1;
	LCD_CS = 1;
}

//---------------------------------------------------------
//function:	lcd write many datas
//parameters:	byte addr, byte *dispbuf, byte n
//return value:	none
//---------------------------------------------------------
void lcd_write_buf( byte addr, byte *dispbuf, byte n )
{
	byte rwdata;
	byte i,j,k;
	
	LCD_CS = 0;
    LCD_WR = 1;
	for ( k = 0; k < 2; k++ );
	rwdata = 0x05;
	for ( i = 0; i < 3; i++ ) 
    {
		if ( rwdata & 0x04 )
			LCD_DATA = 1;
		else
			LCD_DATA = 0;
		for ( k = 0; k < 2; k++ );
		//LCD_WR = 0;
        LCD_CLK = 0;
		for ( k = 0; k < 5; k++ );
		//LCD_WR = 1;
        LCD_CLK = 1;
        NOP();
		rwdata <<= 1;
	}
	rwdata = addr;
	for ( i = 0; i < 6; i++ ) 
   {
		if ( rwdata & 0x20 )
			LCD_DATA = 1;
		else
			LCD_DATA = 0;
		for ( k = 0; k < 2; k++ );
		//LCD_WR = 0;
        LCD_CLK = 0;
		for ( k = 0; k < 5; k++ );
		//LCD_WR = 1;
        LCD_CLK = 1;
        NOP();
		rwdata <<= 1;
	}
	for ( j = 0; j < n; j++ ) 
    {
		rwdata = *dispbuf;
		*dispbuf = 0x00;
		dispbuf++;
		for ( i = 0; i < 8; i++ ) 
        {
			if ( rwdata & 0x01 )
				LCD_DATA = 1;
			else
				LCD_DATA = 0;
			for ( k = 0; k < 2; k++ );
			//LCD_WR = 0;
            LCD_CLK = 0;
			for ( k = 0; k < 5; k++ );
			//LCD_WR = 1;
            LCD_CLK = 1;
            NOP();
			rwdata >>= 1;
		}
	}
	LCD_DATA = 1;
	LCD_CS = 1;
}

//---------------------------------------------------------
//function:	lcd write command
//parameters:	byte command
//return value:	none
//---------------------------------------------------------
void lcd_write_cmd( byte command )
{
	byte rwdata;
	byte i,k;
	
	LCD_CS = 0;
    LCD_WR = 1;
	for ( k = 0; k < 2; k++ );
	rwdata = 0x04;
	for ( i = 0; i < 3; i++ ) 
    {
		if ( rwdata & 0x04 )
			LCD_DATA = 1;
		else
			LCD_DATA = 0;
		for ( k = 0; k < 2; k++ );
		//LCD_WR = 0;
        LCD_CLK = 0;
		for ( k = 0; k < 5; k++ );
		//LCD_WR = 1;
        LCD_CLK = 1;
        NOP();
		rwdata <<= 1;
	}
	rwdata = command;
	for ( i = 0; i < 8; i++ ) 
    {
		if ( rwdata & 0x80 )
			LCD_DATA = 1;
		else
			LCD_DATA = 0;
		for ( k = 0; k < 2; k++ );
		//LCD_WR = 0;
        LCD_CLK = 0;
		for ( k = 0; k < 5; k++ );
		//LCD_WR = 1;
        LCD_CLK = 1;
        NOP();
		rwdata <<= 1;
	}
	LCD_DATA = 1;
	for ( k = 0; k < 2; k++ );
	//LCD_WR = 0;
    LCD_CLK = 0;
	for ( k = 0; k < 5; k++ );
	//LCD_WR = 1;
    LCD_CLK = 1;
    NOP();
	LCD_CS = 1;
}

//---------------------------------------------------------
//function:	lcd on
//parameters:	none
//return value:	none
//---------------------------------------------------------
void lcd_on( void )
{
	lcd_write_cmd( LCD_SYSEN_CMD );
	lcd_write_cmd( LCD_ON_CMD );
}

//---------------------------------------------------------
//function:	lcd off
//parameters:	none
//return value:	none
//---------------------------------------------------------
void lcd_off( void )
{
	lcd_write_cmd( LCD_OFF_CMD );
	lcd_write_cmd( LCD_SYSDIS_CMD );
}




//---------------------------------------------------------
//function:	display init
//parameters:	none
//return value:	none
//---------------------------------------------------------
void disp_init( void )
{
    disp_clear();
    disp_RFM(LCD_RAM_SEG18,TypeID);
    disp_FREQ(FreqSel);
    //disp_TX(0);
    //disp_RX(0);
    disp_RSSI(rf_rssi_value);
    disp_PWR(rfm_pwr);
    disp_BR(rfm_br);
    disp_FDEV(rfm_fdev);
    //disp_BW(200);
}

void disp_clear(void)
{
	byte j;
	lcddisp[0] = 0x00;
	for ( j = 0; j < 32; j++ )
    {
		lcd_write_data( j*2, lcddisp[0] );
    }
}
void disp_RFM(byte addr , byte TY)
{
    byte temp;
    temp = TY;
	lcddisp[11] = font_tab[(temp>>4)];
	lcddisp[12] = font_tab[(temp & 0x0F)];
    lcddisp[13] |= 0x80;
    lcd_write_data(addr,lcddisp[11]);
    lcd_write_data((addr-2),lcddisp[12]);
    lcd_write_data(LCD_RAM_SEG16 , lcddisp[13]);
}
void disp_FREQ(byte freq)
{
    byte temp;
    temp = freq;
    switch(temp)
    {
        case 1:
                 lcddisp[6] = font_tab[3];
                 lcddisp[7] = font_tab[1];
                 lcddisp[8] = font_tab[5];
                 lcddisp[10] = font_tab[0];
                 lcddisp[0] = 0x03;
                 break;
        case 2:
                 lcddisp[6] = font_tab[4] | 0x80;
                 lcddisp[7] = font_tab[3];
                 lcddisp[8] = font_tab[4];
                 lcddisp[10] = font_tab[0]&0x7f;
                 lcddisp[0] = 0x03;
                 break;
        case 3:
                 lcddisp[6] = font_tab[8];
                 lcddisp[7] = font_tab[6];
                 lcddisp[8] = font_tab[8];
                 lcddisp[10] = font_tab[0] | 0x80;
                 lcddisp[0] = 0x03;
                 break;
        case 4:
                 lcddisp[6] = font_tab[9];
                 lcddisp[7] = font_tab[1];
                 lcddisp[8] = font_tab[5];
                 lcddisp[10] = font_tab[0];
                 lcddisp[0] = 0x83;
                 break;
        default:
                 break;
    }
    lcddisp[5] = font_tab[0]&0x7f;
    lcddisp[9] = font_tab[0] | 0x80;
    lcd_write_data(LCD_RAM_SEG25,lcddisp[5]);
    lcd_write_data(LCD_RAM_SEG24,lcddisp[6]);
    lcd_write_data(LCD_RAM_SEG23,lcddisp[7]);
    lcd_write_data(LCD_RAM_SEG22,lcddisp[8]);
    lcd_write_data(LCD_RAM_SEG21,lcddisp[9]);
    lcd_write_data(LCD_RAM_SEG20,lcddisp[10]);
    lcd_write_data(LCD_RAM_SEG19,lcddisp[0]);
}
void shin_FREQ(void)
{
    key3frame = 0;
    while(1)
    {
        lcd_write_data(LCD_RAM_SEG25,0);
        lcd_write_data(LCD_RAM_SEG24,0);
        lcd_write_data(LCD_RAM_SEG23,0);
        lcd_write_data(LCD_RAM_SEG22,0);
        lcd_write_data(LCD_RAM_SEG21,0);
        lcd_write_data(LCD_RAM_SEG20,0);
        lcd_write_data(LCD_RAM_SEG19,lcddisp[0]);
        for(systime=0;systime<250;);


 
        lcd_write_data(LCD_RAM_SEG25,lcddisp[5]);
        lcd_write_data(LCD_RAM_SEG24,lcddisp[6]);
        lcd_write_data(LCD_RAM_SEG23,lcddisp[7]);
        lcd_write_data(LCD_RAM_SEG22,lcddisp[8]);
        lcd_write_data(LCD_RAM_SEG21,lcddisp[9]);
        lcd_write_data(LCD_RAM_SEG20,lcddisp[10]);
        lcd_write_data(LCD_RAM_SEG19,lcddisp[0]);

        for(systime=0;systime<350;)
        {
             Keyscan();
             if((key_down == 1)&&(key4frame == 1))
             {
                  key4count++;
                  key4frame = 0;
                  if(key4count>4)
                  {    key4count = 0; }
                  lcddisp[9] = font_tab[2*key4count] | 0x80;
                  break;
             } 
             /*else if((key_down == 1)&&(key2frame == 1))
             {
                  key2count++;
                  key2frame = 0;
                  if(key2count>4)
                  {    key2count = 0; }
                  lcddisp[9] = font_tab[10-(2*key4count)] | 0x80;
                  lcddisp[8] = lcddisp[8]-1;
                  break;
             }*/ 
             if((key_down == 1)&&(key3frame == 1))
             {
                  key3count++;
                  break;
             }
        }
        if((key_down == 1)&&(key3frame == 1))
        {
            key3frame = 0;
            break;
        }
    }
}
void disp_TX(word tcount)
{
    byte temp;
    if(tcount<10)
    {
        temp = (byte)tcount;
	    lcddisp[1] = 0;
	    lcddisp[2] = 0;
	    lcddisp[3] = 0;
	    lcddisp[4] = font_tab[temp];
    }
    else if((tcount>9)&&(tcount<100))
    {
	    lcddisp[1] = 0;
	    lcddisp[2] = 0;
        temp = (byte)(tcount/10);
	    lcddisp[3] = font_tab[temp];
        temp = (byte)(tcount%10);
	    lcddisp[4] = font_tab[temp];
    }
    else if((tcount>99)&&(tcount<1000))
    {
	    lcddisp[1] = 0;
        temp = (byte)(tcount/100);
	    lcddisp[2] = font_tab[temp];
        temp = (byte)((tcount%100)/10);
	    lcddisp[3] = font_tab[temp];
        temp = (byte)((tcount%100)%10);
	    lcddisp[4] = font_tab[temp];
    }
    else if(tcount>999)
    {
        tcount = 0;
	    lcddisp[1] = 0;
	    lcddisp[2] = 0;
	    lcddisp[3] = 0;
	    lcddisp[4] = font_tab[tcount];
    }
    lcddisp[17] = lcddisp[17] | 0x80;
    lcd_write_data(LCD_RAM_SEG29,lcddisp[1]);
    lcd_write_data(LCD_RAM_SEG28,lcddisp[2]);
    lcd_write_data(LCD_RAM_SEG27,lcddisp[3]);
    lcd_write_data(LCD_RAM_SEG26,lcddisp[4]);
    lcd_write_data(LCD_RAM_SEG12,lcddisp[17]);
}
void clear_TX(void)
{
    lcd_write_data(LCD_RAM_SEG29,0);
    lcd_write_data(LCD_RAM_SEG28,0);
    lcd_write_data(LCD_RAM_SEG27,0);
    lcd_write_data(LCD_RAM_SEG26,0);
    lcd_write_data(LCD_RAM_SEG12,0);
}
void disp_TXtest(void)
{
    lcddisp[1] = font_tab[16];
    lcddisp[2] = font_tab[14];
	lcddisp[3] = font_tab[17];
    lcddisp[4] = font_tab[16];
    lcddisp[17] = lcddisp[17] | 0x80;
    lcd_write_data(LCD_RAM_SEG29,lcddisp[1]);
    lcd_write_data(LCD_RAM_SEG28,lcddisp[2]);
    lcd_write_data(LCD_RAM_SEG27,lcddisp[3]);
    lcd_write_data(LCD_RAM_SEG26,lcddisp[4]);
    lcd_write_data(LCD_RAM_SEG12,lcddisp[17]);
}
void disp_RSSI(byte value)
{
    lcddisp[20] |= 0x80;
    if(value<40)
    {
        lcddisp[1] |= 0x80;
	    lcddisp[2] &= 0x7f;
	    lcddisp[3] &= 0x7f;
	    lcddisp[4] &= 0x7f;
    }
    else if((value>40)&&(value<100))
    {
        lcddisp[1] |= 0x80;
	    lcddisp[2] |= 0x80;
	    lcddisp[3] &= 0x7f;
	    lcddisp[4] &= 0x7f;
    }
    else if((value>100)&&(value<150))
    {
        lcddisp[1] |= 0x80;
	    lcddisp[2] |= 0x80;
	    lcddisp[3] |= 0x80;
	    lcddisp[4] &= 0x7f;
    }
    else if(value>150)
    {
        lcddisp[1] |= 0x80;
	    lcddisp[2] |= 0x80;
	    lcddisp[3] |= 0x80;
	    lcddisp[4] |= 0x80;
    }
    lcd_write_data(LCD_RAM_SEG29,lcddisp[1]);
    lcd_write_data(LCD_RAM_SEG28,lcddisp[2]);
    lcd_write_data(LCD_RAM_SEG27,lcddisp[3]);
    lcd_write_data(LCD_RAM_SEG26,lcddisp[4]);
    lcd_write_data(LCD_RAM_SEG0,lcddisp[20]);
}
void disp_RX(word rcount)
{
    byte temp;
    if(rcount<10)
    {
        temp = (byte)rcount;
	    lcddisp[20] = 0x80;
	    lcddisp[21] = 0x80;
	    lcddisp[22] = 0;
	    lcddisp[23] = font_tab[temp];
    }
    else if((rcount>9)&&(rcount<100))
    {
	    lcddisp[20] = 0x80;
	    lcddisp[21] = 0x80;
        temp = (byte)(rcount/10);
	    lcddisp[22] = font_tab[temp];
        temp = (byte)(rcount%10);
	    lcddisp[23] = font_tab[temp];
    }
    else if((rcount>99)&&(rcount<1000))
    {
	    lcddisp[20] = 0x80;
        temp = (byte)(rcount/100);
	    lcddisp[21] = font_tab[temp]|0x80;
        temp = (byte)((rcount%100)/10);
	    lcddisp[22] = font_tab[temp];
        temp = (byte)((rcount%100)%10);
	    lcddisp[23] = font_tab[temp];
    }
    else if(rcount>999)
    {
        rcount = 0;
	    lcddisp[20] = 0x80;
	    lcddisp[21] = 0x80;
	    lcddisp[22] = 0;
	    lcddisp[23] = font_tab[0];
    }
	//lcddisp[20] |= font_tab[0];
	//lcddisp[21] = font_tab[0] |= 0x80;
	//lcddisp[22] = font_tab[0] & 0x7f;
	//lcddisp[23] = font_tab[0] & 0x7f;
    lcd_write_data(LCD_RAM_SEG0,lcddisp[20]);
    lcd_write_data(LCD_RAM_SEG1,lcddisp[21]);
    lcd_write_data(LCD_RAM_SEG2,lcddisp[22]);
    lcd_write_data(LCD_RAM_SEG3,lcddisp[23]);
}
void clear_RX(void)
{
    lcd_write_data(LCD_RAM_SEG0,0);
    lcd_write_data(LCD_RAM_SEG1,0);
    lcd_write_data(LCD_RAM_SEG2,0);
    lcd_write_data(LCD_RAM_SEG3,0);
}
void disp_RXtest(void)
{
	lcddisp[20] = font_tab[16] | 0x80;
	lcddisp[21] = font_tab[14] | 0x80;
	lcddisp[22] = font_tab[17];
	lcddisp[23] = font_tab[16];
    lcd_write_data(LCD_RAM_SEG0,lcddisp[20]);
    lcd_write_data(LCD_RAM_SEG1,lcddisp[21]);
    lcd_write_data(LCD_RAM_SEG2,lcddisp[22]);
    lcd_write_data(LCD_RAM_SEG3,lcddisp[23]);
}
void disp_BR(byte br)
{
    byte temp;

    if(br>100)
    {
        temp = br/100;  
        lcddisp[17] |= font_tab[temp];
        temp = (br%100)/10;
        lcddisp[18] = font_tab[temp] | 0x80;
        temp = (br%100)%10;
        lcddisp[19] = font_tab[temp] | 0x80;
    }
    else
    {
        lcddisp[17] &=0x80;
        temp = br/10;
        lcddisp[18] = font_tab[temp] | 0x80;
        temp = br%10;
        lcddisp[19] = font_tab[temp] | 0x80;
    }
    lcd_write_data(LCD_RAM_SEG12,lcddisp[17]);
    lcd_write_data(LCD_RAM_SEG11,lcddisp[18]);
    lcd_write_data(LCD_RAM_SEG4,lcddisp[19]);
}
void shin_BR()
{
    byte temp;
    while(1)
    {
        lcd_write_data(LCD_RAM_SEG12,0x80);
        lcd_write_data(LCD_RAM_SEG11,0);
        lcd_write_data(LCD_RAM_SEG4,0);
        for(systime=0;systime<200;);
        if(rfm_br>100)
        {
            temp = rfm_br/100;  
            lcddisp[17] |= font_tab[temp];
            temp = (rfm_br%100)/10;
            lcddisp[18] = font_tab[temp] | 0x80;
            temp = (rfm_br%100)%10;
            lcddisp[19] = font_tab[temp] | 0x80;
        }
        else
        {
            lcddisp[17] &=0x80;
            temp = rfm_br/10;
            lcddisp[18] = font_tab[temp] | 0x80;
            temp = rfm_br%10;
            lcddisp[19] = font_tab[temp] | 0x80;
        }
        lcd_write_data(LCD_RAM_SEG12,lcddisp[17]);
        lcd_write_data(LCD_RAM_SEG11,lcddisp[18]);
        lcd_write_data(LCD_RAM_SEG4,lcddisp[19]);

        for(systime=0;systime<350;)
        {
            Keyscan();
            if((key_down == 1) && (key4frame == 1))
            {
                key4frame = 0;
                if(rfm_br == 12)
                {
                    rfm_br = 24;
                    break;
                }
                else if(rfm_br == 24)
                {
                    rfm_br = 48;
                    break;
                }
                else if(rfm_br == 48)
                {
                    rfm_br = 96;
                    break;
                }
                else if(rfm_br == 96)
                {
                    rfm_br = 12;
                    break;
                }
            }
            else if((key_down == 1) && (key2frame == 1)) 
            {
                key2frame = 0;
                if(rfm_br == 12)
                {
                    rfm_br = 96;
                    break;
                }
                else if(rfm_br == 24)
                {
                    rfm_br = 12;
                    break;
                }
                else if(rfm_br == 48)
                {
                    rfm_br = 24;
                    break;
                }
                else if(rfm_br == 96)
                {
                    rfm_br = 48;
                    break;
                }
            }
            else if((key_down == 1) && (key3frame == 1)) 
            {
                key3count++;
                break;
            }
            //for(systime1=0;systime1<100;); 
        }
        //Keyscan();
        if((key_down == 1) && (key3frame == 1)) 
        {
           key3frame = 0;
           break;
        }
        //for(systime1=0;systime1<100;);
    }
}
void disp_PWR(byte pwr)
{
    byte temp;
    temp = pwr/10;
    lcddisp[15] = font_tab[temp];
    temp = pwr%10;
    lcddisp[16] = font_tab[temp] | 0x80; 
    lcd_write_data(LCD_RAM_SEG14,lcddisp[15]);
    lcd_write_data(LCD_RAM_SEG13,lcddisp[16]);
}
void shin_PWR()
{
    byte temp=0;
    while(1)
    {
        lcd_write_data(LCD_RAM_SEG14,0);
        lcd_write_data(LCD_RAM_SEG13,0);
        for(systime=0;systime<250;);

        temp = rfm_pwr/10;
        lcddisp[15] = font_tab[temp];
        temp = rfm_pwr%10;
        lcddisp[16] = font_tab[temp] | 0x80; 
        lcd_write_data(LCD_RAM_SEG14,lcddisp[15]);
        lcd_write_data(LCD_RAM_SEG13,lcddisp[16]);
        for(systime=0;systime<350;)
        {
            Keyscan();
            if((key_down == 1) && (key4frame == 1))
            {
                key4frame = 0;
                if(rfm_pwr == 1)
                {
                    rfm_pwr = 4;
                    break;
                }
                else if(rfm_pwr == 4)
                {
                    rfm_pwr = 7;
                    break;
                }
                else if(rfm_pwr == 7)
                {
                    rfm_pwr = 10;
                    break;
                }
                else if(rfm_pwr == 10)
                {
                    rfm_pwr = 13;
                    break;
                }
            }
            else if((key_down == 1) && (key2frame == 1)) 
            {
                key2frame = 0;
                if(rfm_pwr == 13)
                {
                    rfm_pwr = 10;
                    break;
                }
                else if(rfm_pwr == 10)
                {
                    rfm_pwr = 7;
                    break;
                }
                else if(rfm_pwr == 7)
                {
                    rfm_pwr = 4;
                    break;
                }
                else if(rfm_pwr == 4)
                {
                    rfm_pwr = 1;
                    break;
                }
            }
            else if((key_down == 1) && (key3frame == 1)) 
            {
                key3count++;
                break;
            }
            //for(systime1=0;systime1<100;); 
        }
        //Keyscan();
        if((key_down == 1) && (key3frame == 1)) 
        {
           key3frame = 0;
           break;
        }

    }  
}
void disp_FDEV(word fdev)
{
    byte temp;
    temp = fdev/100;  
    lcddisp[24] |= font_tab[temp];
    temp = (fdev%100)/10;
    lcddisp[25] = font_tab[temp] | 0x80;
    temp = (fdev%100)%10;
    lcddisp[26] = font_tab[temp] | 0x80;
    lcd_write_data(LCD_RAM_SEG5,lcddisp[24]);
    lcd_write_data(LCD_RAM_SEG6,lcddisp[25]);
    lcd_write_data(LCD_RAM_SEG7,lcddisp[26]);
}
void shin_FDEV()
{
    byte temp;
    while(1)
    {
        lcd_write_data(LCD_RAM_SEG5,0);
        lcd_write_data(LCD_RAM_SEG6,0);
        lcd_write_data(LCD_RAM_SEG7,0);
        for(systime=0;systime<250;);
        temp = rfm_fdev/100;  
        lcddisp[24] = font_tab[temp];
        temp = (rfm_fdev%100)/10;
        lcddisp[25] = font_tab[temp] | 0x80;
        temp = (rfm_fdev%100)%10;
        lcddisp[26] = font_tab[temp] | 0x80;
        lcd_write_data(LCD_RAM_SEG5,lcddisp[24]);
        lcd_write_data(LCD_RAM_SEG6,lcddisp[25]);
        lcd_write_data(LCD_RAM_SEG7,lcddisp[26]);
        for(systime=0;systime<350;)
        {
            Keyscan();
            if((key_down == 1) && (key4frame == 1))
            {
                key4frame = 0;
                if(rfm_fdev == 300)
                {
                    rfm_fdev = 350;
                    break;
                }
                else if(rfm_fdev == 350)
                {
                    rfm_fdev = 400;
                    break;
                }
                else if(rfm_fdev == 400)
                {
                    rfm_fdev = 450;
                    break;
                }
                else if(rfm_fdev == 450)
                {
                    rfm_fdev = 300;
                    break;
                }
            }
            else if((key_down == 1) && (key2frame == 1)) 
            {
                key2frame = 0;
                if(rfm_fdev == 450)
                {
                    rfm_fdev = 400;
                    break;
                }
                else if(rfm_fdev == 400)
                {
                    rfm_fdev = 350;
                    break;
                }
                else if(rfm_fdev == 350)
                {
                    rfm_fdev = 300;
                    break;
                }
                else if(rfm_fdev == 300)
                {
                    rfm_fdev = 450;
                    break;
                }
            }
            else if((key_down == 1) && (key3frame == 1)) 
            {
                key3count++;
                break;
            }
            //for(systime1=0;systime1<100;); 
        }
        //Keyscan();
        if((key_down == 1) && (key3frame == 1)) 
        {
           key3frame = 0;
           break;
        }
    }
}
         
void disp_BW(word bw)
{
    byte temp;

    temp = bw/100;  
    lcddisp[27] |= font_tab[temp];
    temp = (bw%100)/10;
    lcddisp[28] = font_tab[temp] & 0x7f;
    temp = (bw%100)%10;
    lcddisp[29] = font_tab[temp] | 0x80;
    lcd_write_data(LCD_RAM_SEG8,lcddisp[27]);
    lcd_write_data(LCD_RAM_SEG9,lcddisp[28]);
    lcd_write_data(LCD_RAM_SEG10,lcddisp[29]);
}
//---------------------------------------------------------
//function:	display process
//parameters:	none
//return value:	none
//---------------------------------------------------------
/*void disp_proc( void )
{
	if ( delaymsc( jmsdisp ) < 200 )
		return;
	jmsdisp = jms;
	if ( disp.setcnt ) {
		disp.setcnt--;
		if ( disp.setcnt & 0x01 ) {
			lcd_write_data( LCD_ADDR_FREQ, 0x00 );
			lcd_write_buf( LCD_ADDR_TIME, lcddisp, 6 );
			lcd_write_data( LCD_ADDR_PWR, 0x80 );
			disp_littleendpk( LCD_ADDR_DR, 0x00 );
			disp_littleendpk( LCD_ADDR_FDEV, 0x00 );
			disp_bigendpk( LCD_ADDR_BW, 0x00 );
		}
		else {
			lcd_write_data( LCD_ADDR_FREQ, ( 1<<config.frequence | 0x10<<config.mcuosc ) );
			//disp_time ( rtc );
			lcd_write_data( LCD_ADDR_PWR, (font_tab[config.txpower] | 0x80) );
			disp_littleendpk( LCD_ADDR_DR, dr_tab[config.datarate] );
			disp_littleendpk( LCD_ADDR_FDEV, fdev_tab[config.fdevation] );
			disp_bigendpk( LCD_ADDR_BW, bw_tab[config.bandwidth] );
		}
	}
	if ( disp.freqcnt ) {
		disp.freqcnt--;
		if ( disp.freqcnt & 0x01 ) {
			lcd_write_data( LCD_ADDR_FREQ, ( 0x10<<config.mcuosc ) );
		}
		else {
			lcd_write_data( LCD_ADDR_FREQ, ( 1<<config.frequence | 0x10<<config.mcuosc ) );
		}
	}
	if ( disp.osccnt ) {
		disp.osccnt--;
		if ( disp.osccnt & 0x01 ) {
			lcd_write_data( LCD_ADDR_FREQ, ( 1<<config.frequence ) );
		}
		else {
			lcd_write_data( LCD_ADDR_FREQ, ( 1<<config.frequence | 0x10<<config.mcuosc ) );
		}
	}
	if ( disp.hourcnt ) {
		disp.hourcnt--;
		if ( disp.hourcnt & 0x01 ) {
			lcddisp[0] = 0x80;
			lcd_write_buf( LCD_ADDR_TIME+8, lcddisp, 2 );
		}
		else {
			disp_time ( rtc );
		}
	}
	if ( disp.mincnt ) {
		disp.mincnt--;
		if ( disp.mincnt & 0x01 ) {
			lcd_write_buf( LCD_ADDR_TIME+4, lcddisp, 2 );
		}
		else {
			disp_time ( rtc );
		}
	}
	if ( disp.seccnt ) {
		disp.seccnt--;
		if ( disp.seccnt & 0x01 ) {
			lcddisp[1] = 0x80;
			lcd_write_buf( LCD_ADDR_TIME, lcddisp, 2 );
		}
		else {
			disp_time ( rtc );
		}
	}
	if ( disp.rfpwrcnt ) {
		disp.rfpwrcnt--;
		if ( disp.rfpwrcnt & 0x01 ) {
			lcd_write_data( LCD_ADDR_PWR, 0x80 );
		}
		else {
			lcd_write_data( LCD_ADDR_PWR, (font_tab[config.txpower] | 0x80) );
		}
	}
	if ( disp.rfdrcnt ) {
		disp.rfdrcnt--;
		if ( disp.rfdrcnt & 0x01 ) {
			disp_littleendpk( LCD_ADDR_DR, 0x00 );
		}
		else {
			disp_littleendpk( LCD_ADDR_DR, dr_tab[config.datarate] );
		}
	}
	if ( disp.rffdevcnt ) {
		disp.rffdevcnt--;
		if ( disp.rffdevcnt & 0x01 ) {
			disp_littleendpk( LCD_ADDR_FDEV, 0x00 );
		}
		else {
			disp_littleendpk( LCD_ADDR_FDEV, fdev_tab[config.fdevation] );
		}
	}
	if ( disp.rfbwcnt ) {
		disp.rfbwcnt--;
		if ( disp.rfbwcnt & 0x01 ) {
			disp_bigendpk( LCD_ADDR_BW, 0x00 );
		}
		else {
			disp_bigendpk( LCD_ADDR_BW, bw_tab[config.bandwidth] );
		}
	}
}*/

//---------------------------------------------------------
//function:	lcd test
//parameters:	none
//return value:	none
//---------------------------------------------------------
void lcdtest( void )
{
	byte i,j,k,datatmp;
	for ( k = 0; k < 2; k++ ) {
		datatmp = 0x01;
		lcddisp[0] = 0;
		for ( i = 0; i < 8; i++ ){
			lcddisp[0] |= datatmp;
			for ( j = 0; j < 32; j++ ) {
				lcd_write_data( j*2, lcddisp[0] );
			}
			datatmp <<= 1;
            for(systime=0;systime<100;);
			//delayms( 125 );
			//if ( !SW01 )
			//	break;
		}
		//if ( !SW01 )
		//	break;
		//delayms( 500 );
		for(systime=0;systime<500;);
		lcddisp[0] = 0x00;
		for ( j = 0; j < 32; j++ ) 
        {
			lcd_write_data( j*2, lcddisp[0] );
		}
		lcddisp[0] = 0xff;
		for ( j = 0; j < 32; j++ )
        {
			lcd_write_data( j*2, lcddisp[0] );
            for(systime=0;systime<100;);
		}
        for(systime=0;systime<500;);
	}
	lcddisp[0] = 0x00;
	for ( j = 0; j < 32; j++ ) {
		lcd_write_data( j*2, lcddisp[0] );
	}
}
