/****************************************************************
                 LCD.h
*****************************************************************/
#include "DK-1519.h"

#define LCD_SYSDIS_CMD		0x00         //close the crystal and lcd bias generator
#define LCD_SYSEN_CMD		0x01         //open the crystal
#define LCD_OFF_CMD		    0x02         //close the lcd display
#define LCD_ON_CMD	        0x03         //open the lcd display
#define LCD_TIMERDIS_CMD	0x04         //disable base timer output
#define LCD_WDTDIS_CMD		0x05         //disable WDT counter full state output
#define LCD_TIMEREN_CMD		0x06         //enable base time output
#define LCD_WDTEN_CMD		0x07         //enable WDT counter full state output
#define LCD_TONEOFF_CMD		0x08         //close buzeer output
#define LCD_CLRTIMER_CMD	0x0d         //clear base timer
#define LCD_CLRWDT_CMD		0x0f         //clear WDT counter

#define LCD_RAM_SEG0		0x00         //
#define LCD_RAM_SEG1		0x02         //
#define LCD_RAM_SEG2		0x04         //
#define LCD_RAM_SEG3		0x06         //
#define LCD_RAM_SEG4		0x08         //
#define LCD_RAM_SEG5		0x0a         //
#define LCD_RAM_SEG6		0x0c         //
#define LCD_RAM_SEG7		0x0e         //
#define LCD_RAM_SEG8		0x10
#define LCD_RAM_SEG9		0x12
#define LCD_RAM_SEG10		0x14
#define LCD_RAM_SEG11		0x16
#define LCD_RAM_SEG12		0x18
#define LCD_RAM_SEG13		0x1a
#define LCD_RAM_SEG14		0x1c
#define LCD_RAM_SEG15		0x1e
#define LCD_RAM_SEG16		0x20
#define LCD_RAM_SEG17		0x22
#define LCD_RAM_SEG18		0x24
#define LCD_RAM_SEG19		0x26
#define LCD_RAM_SEG20		0x28
#define LCD_RAM_SEG21		0x2a
#define LCD_RAM_SEG22		0x2c
#define LCD_RAM_SEG23		0x2e
#define LCD_RAM_SEG24		0x30
#define LCD_RAM_SEG25		0x32
#define LCD_RAM_SEG26		0x34
#define LCD_RAM_SEG27		0x36
#define LCD_RAM_SEG28		0x38
#define LCD_RAM_SEG29		0x3a
#define LCD_RAM_SEG30		0x3c
#define LCD_RAM_SEG31		0x3e

#define LCD_ADDR_TX	        0x18          //TX addr display
#define LCD_ADDR_RX	        0x02          //RX addr display
#define LCD_ADDR_BW	        0x14          //BW addr display
#define LCD_ADDR_DR	        0x08          //DR addr display
#define LCD_ADDR_FDEV		0x0e          //FDEV addr display
//#define LCD_ADDR_VOL		0x22          //VOL addr display
//#define LCD_ADDR_FREQ		0x2a          //FREQ addr display
#define LCD_ADDR_RSSI		0x00          //RSSI addr display
#define LCD_ADDR_RSSI1      0x34          //
#define LCD_ADDR_RSSI2      0x36          //
#define LCD_ADDR_RSSI3      0x38          //
#define LCD_ADDR_RSSI4      0x3a          //
#define LCD_ADDR_HOPERF     0x20          //
#define LCD_ADDR_RFM        0x26          //
#define LCD_ADDR_TIME		0x2e          //TIME addr display
#define LCD_ADDR_PWR		0x1a          //PWR addr display

struct dispflash {
    byte  RSSI;
    byte  BR;
    byte  PWR;
    word  FDEV;
    word  BW;
};

struct time {
	byte hour;
	byte minute;
	byte second;
};
struct CONFIG
{
	byte frequence;
	byte mcuosc;
	byte txpower;
	byte datarate;
	byte fdevation;
	byte bandwidth;
	unsigned long combitrate;
	word counter;
};

//SBIT(LCD_CS, SFR_P2, 1);
//SBIT(LCD_WR, SFR_P2, 2);
//SBIT(LCD_DATA, SFR_P2, 3);

extern byte lcddisp[32];
extern struct dispflash  disp;
extern byte font_tab[18];

extern void lcd_write_data( byte addr, byte dispdata );
extern void lcd_write_buf( byte addr, byte *dispbuf, byte n );
extern void lcd_write_cmd( byte command );
extern void lcd_on( void );
extern void lcd_off( void );
extern void disp_init( void );
extern void disp_proc( void );
extern void lcdtest( void );
extern void disp_clear(void);
extern void disp_RFM(byte addr,byte TY);
extern void disp_FREQ(byte freq);
extern void disp_TX(word tcount);
extern void disp_RX(word tcount);
extern void disp_RSSI(byte value);
extern void disp_BR(byte br);
extern void disp_PWR(byte pwr);
extern void disp_FDEV(word fdev);
extern void disp_BW(word bw);
extern void shin_FREQ(void);
extern void shin_BR();
extern void shin_PWR();
extern void shin_FDEV();
extern void clear_TX(void);
extern void clear_RX(void);
extern void disp_TXtest(void);
extern void disp_RXtest(void);