/**************************************************************
                rfm68 module config
***************************************************************/
#include "DK-rfm68.h"
#include "Keyscan.h"
#include "lcd.h"
//*******************************************************************
 byte RF68FreqTbl[5][3] = {
	                           {0x1c, 0x2c, 0x4f},	//0	for NC
	                           {0x1b, 0x48, 0x01},	//341MHz for 26MHz
	                           {0x1c, 0x2c, 0x4f},	//434MHz for 26MHz
	                           {0x1c, 0x2c, 0x4f},	//868MHz for 26MHz
	                           {0x1c, 0x66, 0x27},	//915MHz for 26MHz
	                           };

	                           
 byte RF68FdevTbl[5][3] = {//for ForceTx/FSK/35KHz/10dBm/2ms
	                           {0x00, 0x82, 0xD4},  //0 for NC
	                           {0x00, 0x82, 0xD4},  //341MHz for 26MHz
	                           {0x00, 0x82, 0xD4},  //434MHz for 26MHz
							   {0x00, 0xA1, 0x74},  //868MHz for 26MHz	
							   {0x00, 0xA1, 0x74},  //915MHz for 26MHz	
                               };
const byte RF68Fdev433[4][3] = { //for ForceTx/FSK/35KHz/10dBm/2ms
	                           {0x00, 0x82, 0x74},  //30KHz
	                           {0x00, 0x82, 0xD4},  //35KHz
							   {0x00, 0x83, 0x34},  //40KHz	
							   {0x00, 0x83, 0x94},  //45KHz	
                               };
const byte RF68Fdev868915[4][3] = { //for ForceTx/FSK/35KHz/10dBm/2ms
	                           {0x00, 0xA1, 0x54},  //30KHz
	                           {0x00, 0xA1, 0x74},  //35KHz
							   {0x00, 0xA1, 0xB4},  //40KHz	
							   {0x00, 0xA1, 0xD4},  //45KHz	
                               };

const byte RF68Freq433M[5][3] = {
	                           {0x1c, 0x2c, 0x4f},	   //434MHz for 26MHz
                               {0x1c, 0x2c, 0xcd},     //434.2MHz for 26MHz
                               {0x1c, 0x2d, 0x4b},     //434.4MHz for 26MHz
                               {0x1c, 0x2d, 0xc9},     //434.6MHz for 26MHz
                               {0x1c, 0x2e, 0x47},     //434.8MHz for 26MHz
                               };  
const byte RF68Freq868M[5][3] = {
	                           {0x1c, 0x2c, 0x4f},	   //868MHz for 26MHz
                               {0x1c, 0x2c, 0x8e},     //868.2MHz for 26MHz
                               {0x1c, 0x2c, 0xcd},     //868.4MHz for 26MHz
                               {0x1c, 0x2d, 0x0c},     //868.6MHz for 26MHz
                               {0x1c, 0x2d, 0x4b},     //868.8MHz for 26MHz
                               }; 
const byte RF68Freq915M[5][3] = {
	                           {0x1c, 0x66, 0x28},	   //915MHz for 26MHz
                               {0x1c, 0x66, 0x67},     //915.2MHz for 26MHz
                               {0x1c, 0x66, 0xA6},     //915.4MHz for 26MHz
                               {0x1c, 0x66, 0xE5},     //915.6MHz for 26MHz
                               {0x1c, 0x67, 0x24},     //915.8MHz for 26MHz
                               };                               

const byte RF68OOKTbl[5][3] = {//for ForceTx/OOK/10dBm/2ms
	                           {0x00, 0xC2, 0xD4},  //0 for NC
	                           {0x00, 0xC2, 0xD4},  //341MHz for 26MHz
	                           {0x00, 0xC2, 0xD4},  //434MHz for 26MHz
							   {0x00, 0xE1, 0x54},  //434MHz for 26MHz	
							   {0x00, 0xE1, 0x54},  //434MHz for 26MHz	
                               };

const byte RF68SleepTbl[5][3] = {//for AutoTx/FSK/35KHz/10dBm/2ms
	                           {0x00, 0x02, 0xD4},  //0 for NC
	                           {0x00, 0x02, 0xD4},  //341MHz for 26MHz
	                           {0x00, 0x02, 0xD4},  //434MHz for 26MHz
							   {0x00, 0x21, 0x54},  //434MHz for 26MHz	
							   {0x00, 0x21, 0x54},  //434MHz for 26MHz	
                               };
const byte RFM68Data[21] = {
	                  'H', 'o', 'p', 'e', 'R', 'F', ' ', 'R', 'F', 'M', 
	                  ' ', 'C', 'O', 'B', 'R', 'F', 'M', '6', '8', '-', 'S', 
	                  };
byte rateH;
byte rateL;


void RFM_REconfig(void)
{
    switch(rfm_br)
    {
        case 12:
                     rateH = 0xFC;
                     rateL = 0xBE;
                     break;
        case 24:
                     rateH = 0xFE;
                     rateL = 0x68;
                     break;
        case 48:
                     rateH = 0xFF;
                     rateL = 0x2F;
                     break;
        case 96:
                     rateH = 0xFF;
                     rateL = 0x97;
                     break;
        default:
                     break;
    }
    switch(rfm_fdev)
    {
        case 30:
                     RF68FdevTbl[2][1] = RF68Fdev433[0][1];
                     RF68FdevTbl[2][2] = RF68Fdev433[0][2];
                     RF68FdevTbl[3][1] = RF68Fdev868915[0][1];
                     RF68FdevTbl[3][2] = RF68Fdev868915[0][2];
                     RF68FdevTbl[4][1] = RF68Fdev868915[0][1];
                     RF68FdevTbl[4][2] = RF68Fdev868915[0][2];
                     break;
        case 35:
                     RF68FdevTbl[2][1] = RF68Fdev433[1][1];
                     RF68FdevTbl[2][2] = RF68Fdev433[1][2];
                     RF68FdevTbl[3][1] = RF68Fdev868915[1][1];
                     RF68FdevTbl[3][2] = RF68Fdev868915[1][2];
                     RF68FdevTbl[4][1] = RF68Fdev868915[1][1];
                     RF68FdevTbl[4][2] = RF68Fdev868915[1][2];
                     break;
        case 40:
                     RF68FdevTbl[2][1] = RF68Fdev433[2][1];
                     RF68FdevTbl[2][2] = RF68Fdev433[2][2];
                     RF68FdevTbl[3][1] = RF68Fdev868915[2][1];
                     RF68FdevTbl[3][2] = RF68Fdev868915[2][2];
                     RF68FdevTbl[4][1] = RF68Fdev868915[2][1];
                     RF68FdevTbl[4][2] = RF68Fdev868915[2][2];
                     break;
        case 45:
                     RF68FdevTbl[2][1] = RF68Fdev433[3][1];
                     RF68FdevTbl[2][2] = RF68Fdev433[3][2];
                     RF68FdevTbl[3][1] = RF68Fdev868915[3][1];
                     RF68FdevTbl[3][2] = RF68Fdev868915[3][2];
                     RF68FdevTbl[4][1] = RF68Fdev868915[3][1];
                     RF68FdevTbl[4][2] = RF68Fdev868915[3][2];
                     break;
        default:
                     break;
    }
    switch(key4count)
    {
       case 0:
                     RF68FreqTbl[2][0] = RF68Freq433M[0][0];
                     RF68FreqTbl[2][1] = RF68Freq433M[0][1];
                     RF68FreqTbl[2][2] = RF68Freq433M[0][2];
                     RF68FreqTbl[3][0] = RF68Freq868M[0][0];
                     RF68FreqTbl[3][1] = RF68Freq868M[0][1];
                     RF68FreqTbl[3][2] = RF68Freq868M[0][2];
                     RF68FreqTbl[4][0] = RF68Freq915M[0][0];
                     RF68FreqTbl[4][1] = RF68Freq915M[0][1];
                     RF68FreqTbl[4][2] = RF68Freq915M[0][2];
                     break;
       case 1:
                     RF68FreqTbl[2][0] = RF68Freq433M[1][0];
                     RF68FreqTbl[2][1] = RF68Freq433M[1][1];
                     RF68FreqTbl[2][2] = RF68Freq433M[1][2];
                     RF68FreqTbl[3][0] = RF68Freq868M[1][0];
                     RF68FreqTbl[3][1] = RF68Freq868M[1][1];
                     RF68FreqTbl[3][2] = RF68Freq868M[1][2];
                     RF68FreqTbl[4][0] = RF68Freq915M[1][0];
                     RF68FreqTbl[4][1] = RF68Freq915M[1][1];
                     RF68FreqTbl[4][2] = RF68Freq915M[1][2];
                     break;
       case 2:
                     RF68FreqTbl[2][0] = RF68Freq433M[2][0];
                     RF68FreqTbl[2][1] = RF68Freq433M[2][1];
                     RF68FreqTbl[2][2] = RF68Freq433M[2][2];
                     RF68FreqTbl[3][0] = RF68Freq868M[2][0];
                     RF68FreqTbl[3][1] = RF68Freq868M[2][1];
                     RF68FreqTbl[3][2] = RF68Freq868M[2][2];
                     RF68FreqTbl[4][0] = RF68Freq915M[2][0];
                     RF68FreqTbl[4][1] = RF68Freq915M[2][1];
                     RF68FreqTbl[4][2] = RF68Freq915M[2][2];
                     break;
       case 3:
                     RF68FreqTbl[2][0] = RF68Freq433M[3][0];
                     RF68FreqTbl[2][1] = RF68Freq433M[3][1];
                     RF68FreqTbl[2][2] = RF68Freq433M[3][2];
                     RF68FreqTbl[3][0] = RF68Freq868M[3][0];
                     RF68FreqTbl[3][1] = RF68Freq868M[3][1];
                     RF68FreqTbl[3][2] = RF68Freq868M[3][2];
                     RF68FreqTbl[4][0] = RF68Freq915M[3][0];
                     RF68FreqTbl[4][1] = RF68Freq915M[3][1];
                     RF68FreqTbl[4][2] = RF68Freq915M[3][2];
                     break;
       case 4:
                     RF68FreqTbl[2][0] = RF68Freq433M[4][0];
                     RF68FreqTbl[2][1] = RF68Freq433M[4][1];
                     RF68FreqTbl[2][2] = RF68Freq433M[4][2];
                     RF68FreqTbl[3][0] = RF68Freq868M[4][0];
                     RF68FreqTbl[3][1] = RF68Freq868M[4][1];
                     RF68FreqTbl[3][2] = RF68Freq868M[4][2];
                     RF68FreqTbl[4][0] = RF68Freq915M[4][0];
                     RF68FreqTbl[4][1] = RF68Freq915M[4][1];
                     RF68FreqTbl[4][2] = RF68Freq915M[4][2];
                     break;
       default:
                     break;
    }
}

/******************************************************************************
**Name      RFM68_EntryTx
**Function  config RFM68 module into TX state
**Input     none
**Output    0abnormal ; 1--normal
******************************************************************************/
byte RFM68_EntryTx(void)
{
	
	TRISA3 = 0;
 	CTRL = 0;
	TRISA2 = 1;
	TRISA1 = 0;
	RFdata = 0;
 
 	RFM68_TWIAccess(RF68FreqTbl[FreqSel]);	//Ƶ
 	RFM68_TWIAccess(RF68FdevTbl[FreqSel]);	//Ƶƫ
 
	systime=0;
	while(!TxRDY)
	{
		Keyscan();
		if(key_down)
			break;
		if(systime>=10)	
 			return(0);
	}
 	if(systime>=5)	
 		return(0);				//return abnormal
 	else
 		return(1);				//return normal		
}

/******************************************************************************
**Name      RFM68_TWIAccess
**Function  config commands to RFM68 module
**Input     ptr pointer parameter
**Output    none
******************************************************************************/
void RFM68_TWIAccess(byte const *ptr)
{
 byte i, j;
 
 for(i=0;i<3;i++)				//send 3 bytes
 {	
 	for(j=0x80;j!=0;j>>=1)		//8 bits left
 	{
 		CTRL = 0;
 		if(ptr[i]&j)
 		{
 			RFdata = 1;
			NOP();
 		}
 		else
 		{	
 			RFdata = 0;
			NOP();
 		}
 		CTRL =1;
		NOP();
		NOP();
		NOP();
 	}
 }				
 CTRL = 0;						//the last bit
 NOP();
 NOP();				
 RFdata = 1;					//if keep low more than 2 ms,it will stop transmitting
 NOP();
 
}

/******************************************************************************
**Name        RFM68_Sleep
**Function    config RFM68 module into sleep mode
**Input       none
**Output      none
******************************************************************************/
void RFM68_Sleep(void)
{
 TRISA3 = 0;
 CTRL = 0;
 TRISA2 = 1;
 TRISA1 = 0;
 RFdata = 0;
 
 RFM68_TWIAccess(RF68SleepTbl[FreqSel]);	//config Auto
 for(systime=0;systime<3;);		//output more than 2 ms then into the sleep
}


/******************************************************************************
**Name         RFM68_TxPacket
**Function     transmit datas
**Input        none
**Output       0----Error ; 1---- transmit datas over
******************************************************************************/		
byte RFM68_TxPacket(void)
{

 byte i, j;
 byte tx_buf[29];

 for(i=0;i<4;i++)
 {
	 tx_buf[i] = 0x55;
 }
 tx_buf[i++]  = 0xAA;
 tx_buf[i++]  = 0x2D;
 tx_buf[i++]  = 0xD4;
 for(j=0;j<21;j++)
 {
	 tx_buf[i++] = RFM68Data[j];
 }
 tx_buf[i]	  = 0xAA;

 for(i=0;i<29;i++) 
 	{
 	for(j=0x80;j!=0;j>>=1)
 		{
			if(tx_buf[i]&j)
			{	RFdata = 1;	}
			else
			{	RFdata = 0;	}
			T1CON = 0x21;			
			TMR1H = rateH;
			TMR1L = rateL;
			while(!TMR1IF)
			{
				if(TxRDY == 0)
					return(0);
				Keyscan();
				if(key_down)
					return(0);
			}
			TMR1IF = 0;
 		}
 	}
 return(1);
}
/******************************************************************************
**Name         RFM68_NormalTX
**Function     transmit datas about 1s
**Input        none
**Output       none
******************************************************************************/	
void RFM68_NormalTX(void)
{
    clear_RX();
    rf_rcount = 0;
    disp_TX(rf_tcount);
	systime1 = 0;
	while(1)
	{
		if(systime1>1000)            //timer 1S
		{
			systime1 = 0;
			if(1 == RFM68_EntryTx())
			{
				if(1 == RFM68_TxPacket())
				{
                     rf_tcount++;
                     led_tx();
	                 disp_TX(rf_tcount);
                 }
			}
			else
			{	RFM68_NRESET();	}
		}
		Keyscan();
		for(systime=0;systime<100;);
		if(key_down)
		    break;
         //}      
	}
}
/******************************************************************************
**Name         RFM68_TestTX
**Function     transmit datas countines
**Input        none
**Output       none
******************************************************************************/	
void RFM68_TestTX(void)
{
    //RFM68_EntryTx();
    //while(1)
    //{
	    RFM68_EntryTx();
	    RFM68_TxPacket();
	//    Keyscan();
    //    for(systime=0;systime<100;);
	//    if(key_down)
	//  	    break;
    //}
}
/******************************************************************************
**Name         RFM68_NRESET
**Function     reset the module
**Input        none
**Output       none
******************************************************************************/	
void RFM68_NRESET(void)
{
	TRISD0 = 0;
	PORTD &= 0xFE;
	for(systime=0;systime<20;);
	PORTD |= 0x01;
	for(systime=0;systime<20;);
	TRISD0 = 1;
}                          